<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Configuration Editor</title>
    <script src="https://unpkg.com/htmx.org@1.9.2"></script>
</head>
<body>
    <h1>Configuration Editor</h1>
    <div id="config-container">

        {{/* Loop through grouped configurations */}}
        {{range $group, $items := .}}
        <div id="config-group-{{$group}}" class="config-group">
            <h2>{{$group}}</h2>
            <div class="config-items">
                {{range $items}}
                <div id="config-item-{{$group}}-{{.Name}}" class="config-item">
                    <form hx-put="/configs/{{$group}}.{{.Name}}" hx-target="#config-item-{{$group}}-{{.Name}}" hx-swap="innerHTML"> 
                        <label>{{.Name}}</label>
                        <input type="text" name="stringValue" value="{{if .StringValue.Valid}}{{.StringValue.String}}{{end}}">
                        <input type="text" name="intValue" value="{{if .IntValue.Valid}}{{.IntValue.Int64}}{{end}}">
                        <button type="submit">Update</button>
                        <button type="button" hx-delete="/configs/{{$group}}.{{.Name}}" hx-target="#config-item-{{$group}}-{{.Name}}" hx-swap="outerHTML">Delete</button> 
                    </form>
                </div>
                {{end}}
            </div>
            <form hx-post="/configs" hx-target="#config-group-{{$group}}" hx-swap="innerHTML">
                <label>New Config</label>
                <input type="hidden" name="name" value="{{$group}}."> {{/* Prefix for the new config */}}
                <input type="text" name="newName" placeholder="New Config Name"> 
                <input type="text" name="stringValue" placeholder="String Value">
                <input type="text" name="intValue" placeholder="Int Value">
                <button type="submit">Add</button>
            </form>
        </div>
        {{end}}

        {{/* Section for ungrouped configurations */}}
        <div id="config-group-no-category" class="config-group">
            <h2>No Category</h2>
            <div class="config-items">
                {{range $item := .UngroupedConfigs}}
                <div id="config-item-no-category-{{.Name}}" class="config-item">
                    <form hx-put="/configs/{{.Name}}" hx-target="#config-item-no-category-{{.Name}}" hx-swap="innerHTML">
                        <label>{{.Name}}</label>
                        <input type="text" name="stringValue" value="{{if .StringValue.Valid}}{{.StringValue.String}}{{end}}">
                        <input type="text" name="intValue" value="{{if .IntValue.Valid}}{{.IntValue.Int64}}{{end}}">
                        <button type="submit">Update</button>
                        <button type="button" hx-delete="/configs/{{.Name}}" hx-target="#config-item-no-category-{{.Name}}" hx-swap="outerHTML">Delete</button> 
                    </form>
                </div>
                {{end}}
            </div>
            <form 
				hx-post="/configs/"  
				hx-target="#config-items-no-category" 
				hx-swap="beforeend"  
			>
				<label>New Config</label>
				<input type="text" name="name" placeholder="New Config Name">
				<input type="text" name="stringValue" placeholder="String Value">
				<input type="text" name="intValue" placeholder="Int Value">
				<button type="submit">Add</button>
			</form>
        </div>

    </div>
</body>
</html>